<template>
  <v-flex>
    <v-card class="mx-auto padded" max-width="600">
      <div class="text-center">
        <img
            class="white--text"
            height="70px"
            width="auto"
            src="@/ui/assets/logo_coexya.svg"
            alt="Logo COEXYA"
        />
      </div>

      <template v-if="!resetSent">

        <v-card-text>
          <p class="information">
            {{ $t('forgotPassword.description') }}
          </p>
        </v-card-text>

        <v-text-field v-if="!resetSent" color="var(--var-color-blue-sword)"
                      :label="$t('forgotPassword.usernameEmail')"
                      v-model="usernameOrEmail"
                      @keyup.enter.native="handleForgotPassword"
        />

      </template>
      <template v-else>

        <v-card-actions class="justify-center">
          <v-icon color="green" large>check_circle_outline</v-icon>
        </v-card-actions>

        <v-card-text>
          <p class="information" id="emailSentDescription">
            {{ $t('forgotPassword.emailSentDescription', [maskedEmail]) }}
          </p>
        </v-card-text>

      </template>

      <v-card-actions class="justify-center">
        <v-btn @click="goToLogin()" id="backToLoginButton">
          <v-icon v-if="!resetSent" class="pr-1">arrow_back</v-icon>
          <v-icon v-if="resetSent" class="pr-1">check</v-icon>
          {{ resetSent ? $t('forgotPassword.done') : $t('forgotPassword.back') }}
        </v-btn>
        <v-btn @click="handleForgotPassword" id="nextButton" v-if="!resetSent">
          <v-icon class="pr-1">double_arrow</v-icon>
          {{ $t('forgotPassword.next') }}
        </v-btn>
      </v-card-actions>

      <FeedBackMessage ref="feedBackMessage" with-border="true"/>

      <div class="text-center" id="gcu">
        <a href="/#/GCU">{{ $t('login.gcu') }}</a>
      </div>
    </v-card>
  </v-flex>
</template>

<style type="text/css" scoped>

img {
  margin: 40px 40px 60px 40px;
}

a {
  color: var(--var-color-blue-sword) !important;
  font-size: small;
}

#nextButton {
  margin-top: 20px;
  background-color: var(--var-color-blue-sword);
  color: white;
}

#backToLoginButton {
  margin-top: 20px;
  background-color: var(--var-color-light-orange-sword);
  color: white;
}

#gcu {
  margin-top: 100px;
}

.information {
  text-align: justify;
  text-justify: inter-word;
  white-space: pre-line;
}

.padded {
  padding: 50px 100px;
}

</style>

<script lang="ts">
import {ForgotPwdRequest} from "@/api/types"
import {Component, Ref, Vue} from "vue-property-decorator"
import {FeedBackMessage} from "@/ui/components"

@Component
export default class ForgotPassword extends Vue {

  @Ref() private readonly feedBackMessage!: FeedBackMessage

  private usernameOrEmail: string = ""

  private resetSent: boolean = false
  private maskedEmail: string = ""

  private goToLogin() {
    this.$router.push("/login")
  }

  private async handleForgotPassword() {
    const forgotPwdRequest: ForgotPwdRequest = {usernameOrEmail: this.usernameOrEmail}

    await this.$modules.accounts.resetPassword(forgotPwdRequest).then(async () => {
      this.feedBackMessage.reset()
      this.resetSent = true
      this.maskedEmail = this.$modules.accounts.getMaskedEmail
    }).catch((error) => {
      this.resetSent = false
      this.usernameOrEmail = ""
      const exception = error.response?.data.message
      if (exception === "Invalid credentials") {
        this.feedBackMessage.fail("forgotPassword.errors.invalid_login_or_email")
      } else if (exception === "Disabled account") {
        this.feedBackMessage.fail("errors.login.disabled")
      } else {
        this.feedBackMessage.fail("errors.login.default")
      }
    })
  }

}
</script>
